#ifndef _ISU_DODGEBALL_PLAYER_
#define _ISU_DODGEBALL_PLAYER_

#include <math.h>
#include "Game.h"
#include "ball.h"
#include "isuCode.h"

using namespace std;

enum {DMOVE, DSTAND, DISOUT, DTHROUGH1, DTHROUGH2, DDEFFEND, DHIT};

class Ball;


class Player {
public:

	Player();
	Player(ISUCode *teamCode, unsigned int playerID, unsigned int _teamID, vector<Ball> *_teamBalls, int *_teamScore);
	void draw(bool gameOver, bool winTeam);
	void clock(unsigned long gTime, unsigned int *numBallsLeft);


	Vector drawPos;
	float holdAngle;
	unsigned int holdPower;
	unsigned int drawState;
	bool isHit;
	unsigned long nextStepTimeStamp;
	unsigned int id;
	unsigned int teamID;
	bool notPlaying;
	bool outofCode;
	float angle;
	int *teamScore;
	string teamName;
	float offsetA;
private:

	
	void getState(float *sRight, float *sLeft, float *sTop, float *sBottom, bool gameOver, bool winTeam);

	
	
	unsigned long startTime;
	
	int lineNumber;

	Vector startPos;
	Vector endPos;

	float moveVelocity;
	unsigned int strength;
	unsigned int throughTime;
	
	float offsetX;
	float offsetY;
	

	vector<Ball> *teamBalls;

	
	vector<Instruction> *playerCode;

};


#endif