#ifndef _ISU_DODGEBALL_BALL_
#define _ISU_DODGEBALL_BALL_


#include "utils.h"
#include "Player.h"

#define CROSS(a, b, c) a[0] = b[1]*c[2]-b[2]*c[1]; a[1]=b[2]*c[0]-b[0]*c[2]; a[2]=b[0]*c[1]-b[1]*c[0];
#define DOT(res, ax, ay, az, bx, by, bz) res = ax*bx + ay*by + az*bz;



class Ball {
public:
	Ball() { }
	Ball(unsigned int _team, unsigned int _player, Player *_throwPlayer, Vector _dir, Vector _pos, unsigned int numBounces, unsigned long _startTime);
	void draw();
	void clock(unsigned long gTime);
	void intersect(Player *obj, unsigned long gTime);
	void intersect (Ball *obj, unsigned long gTime);
	void intersectWalls(unsigned long gTime);
	void intersect(Wall obj, unsigned long gTime);

	Vector dir;
	Vector pos;
	Vector old_pos;
	Vector last_pos;
	unsigned int team;
	unsigned int player;
	int bouncesLeft;
	unsigned long startTime;

	bool testSelfCol;
	Player *throwPlayer;
	

};


#endif