#ifndef _ISU_DODGEBALL_ISUCODE_
#define _ISU_DODGEBALL_ISUCODE_

#include <vector>
#include "utils.h"

using namespace std;


enum OPCodes {THROUGH, DEFFEND, MOVE, TURN};

class Instruction {
public:
	Instruction();
	Instruction(OPCodes _opCode) {
		opCode = _opCode;
	}
	Instruction(unsigned int _x, unsigned int _y){
		opCode = MOVE;
		x = _x;
		y=_y;
	}	// move
	Instruction(OPCodes _opCode, unsigned int _repeatCount) {
		opCode = _opCode;
		repeatCount = _repeatCount;
	}	// deffend
	Instruction(float _angle) {
		opCode = TURN;
		angle = _angle;
	}	// turn

	OPCodes opCode;
	float angle;
	unsigned int repeatCount;
	unsigned int x,y;

};


class ISUCode {
public:

	ISUCode(string name);

	void newPlayer(unsigned int playerID,  char* playerType, char* fileName, unsigned int lineNumber);
	vector<Instruction> player[4];

	Vector startPos[4];
	float moveVelocity[4];
	float holdAngle[4];
	unsigned int holdPower[4];
	unsigned int strength[4];
	unsigned int throughTime[4];

	bool set[4];

	string teamName;

private:

	

};


#endif