


#include <GL/gl.h>
#include <GL/glut.h>
#include "utils.h"
#include "isuCode.h"
#include "Game.h"
#include "ball.h"
#include "Player.h"
#include "bitmapLoader.h"

using namespace std;




// window size
static float windowWidth = 640.0f;
static float windowHeight = 480.0f;
static float windowX = 0;
static float windowY = 0;




GAME game;
GLuint texture[6];


void myExit(int exitCode) {

	printf("\n\nPress Enter to continue . . .");
	getchar();
	exit(exitCode);
}



void MyReshape(int x, int y) {

	windowWidth = x;
	windowHeight = y;

	if(x > y) {
		glViewport((x-y)/2,0,y,y);
	} else {
		glViewport(0,(y-x)/2,x,x);
	}
}

void drawTeam(unsigned int teamID) {

	switch(teamID) {
		case 0: glColor3d(0.302f, .996f, 0.462745f); break;
		case 1: glColor3d(1.0f, 1.0f, 1.0f); break;
		case 2: glColor3d(0.282353f, 0.513725f, 0.823529f); break;
		case 3: glColor3d(1.0f, 0.941f, 0.0f); break;
		default: glColor3d(1.0f, 1.0f, 1.0f);
	};


	glPushMatrix();


	glTranslatef(0, BACKDIST, 0);

	glBegin( GL_LINE_STRIP );
		glTexCoord2d(1,0); glVertex2i(ZONEWIDTH, -ZONEHEIGH);
		glTexCoord2d(1,1); glVertex2i(ZONEWIDTH, ZONEHEIGH);
		glTexCoord2d(0,1); glVertex2i(-ZONEWIDTH, ZONEHEIGH);
		glTexCoord2d(0,0); glVertex2i(-ZONEWIDTH, -ZONEHEIGH);
		glTexCoord2d(1,0); glVertex2i(ZONEWIDTH, -ZONEHEIGH);
	glEnd();

	glTranslatef(-ZONEWIDTH, -ZONEHEIGH, 0);

	// draw players
	for(unsigned int i = 0; i < 4; i++) {
		game.players[teamID][i]->draw(game.gameOver, (game.highScore == game.score[teamID]));
	}



	glPopMatrix();

}


// Render A String
void render_string(void* font, const char* string)
{
	char* p = (char*) string;
	while (*p != '\0') glutStrokeCharacter(font, *p++);
}

void MyDisplay( void ) {

	game.clock();

 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();


	// ground
	glColor3d(1.0f, 1.0f, 1.0f);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, texture[0]);

	glBegin( GL_TRIANGLE_STRIP );

		glTexCoord2d(10,0); glVertex2i(RES*(GRID/2), -RES*(GRID/2));
		glTexCoord2d(10,10); glVertex2i(RES*(GRID/2), RES*(GRID/2));
		glTexCoord2d(0,0); glVertex2i(-RES*(GRID/2), -RES*(GRID/2));
		glTexCoord2d(0,10); glVertex2i(-RES*(GRID/2), RES*(GRID/2));

	glEnd();

	glDisable(GL_TEXTURE_2D);

	glColor3d(0.0f, 0.0f, 0.0f);
	glBegin(GL_LINES);
	for(unsigned int i = 0; i < game.gameWalls.size(); i++) {
		glVertex2i(game.gameWalls[i].pt1.x, game.gameWalls[i].pt1.y);
		glVertex2i(game.gameWalls[i].pt2.x, game.gameWalls[i].pt2.y);
	}
	glEnd();



	/*glColor3d(0.0f, 1.0f, 1.0f);

	glBegin( GL_TRIANGLE_STRIP );

		glTexCoord2d(1,0); glVertex2i(RES*((GRID-25)/2), -RES*((GRID-25)/2));
		glTexCoord2d(1,1); glVertex2i(RES*((GRID-25)/2), RES*((GRID-25)/2));
		glTexCoord2d(0,0); glVertex2i(-RES*((GRID-25)/2), -RES*((GRID-25)/2));
		glTexCoord2d(0,1); glVertex2i(-RES*((GRID-25)/2), RES*((GRID-25)/2));

	glEnd();
	*/


	glPushMatrix();

	glBindTexture(GL_TEXTURE_2D, texture[2]);
	drawTeam(0);
	glRotatef(90,0,0,1);
	glBindTexture(GL_TEXTURE_2D, texture[3]);
	drawTeam(1);
	glRotatef(90,0,0,1);
	glBindTexture(GL_TEXTURE_2D, texture[4]);
	drawTeam(2);
	glRotatef(90,0,0,1);
	glBindTexture(GL_TEXTURE_2D, texture[5]);
	drawTeam(3);

	glPopMatrix();

	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, texture[1]);

	if(game.gameOver == false) {
		for(unsigned int j=0; j < 4; j++) {
			switch(j) {
				case 0: glColor3d(0.302f, 0.996f, 0.462745f); break;
				case 1: glColor3d(1.0f, 1.0f, 1.0f); break;
				case 2: glColor3d(0.282353f, 0.513725f, 0.823529f); break;
				case 3: glColor3d(1.0f, 0.941f, 0.0f); break;
				default: glColor3d(1.0f, 1.0f, 1.0f);
			};

			for(unsigned int i = 0; i < game.teamBalls[j].size(); i++) {
				game.teamBalls[j].at(i).draw();
			}
		}
	}
	glDisable(GL_TEXTURE_2D);

	char str[128];
	// Team A score
	glColor3d(0.302f, 0.996f, 0.462745f);
	glPushMatrix();
	glTranslatef((ZONEWIDTH*1.5), -(ZONEWIDTH*2.2),0);
	glScalef(0.15, 0.15,1);
	sprintf(str, "Balls: %d",game.numBallsLeft[0]);
	render_string(GLUT_STROKE_ROMAN, str);
	glPopMatrix();

	glPushMatrix();
	glTranslatef((ZONEWIDTH*1.5), -(ZONEWIDTH*2.0),0);
	glScalef(0.15, 0.15,1);
	sprintf(str, "Score: %d",game.score[0]);
	render_string(GLUT_STROKE_ROMAN, str);
	glPopMatrix();

	glPushMatrix();
	glTranslatef((ZONEWIDTH*1.5), -(ZONEWIDTH*1.8),0);
	glScalef(0.15, 0.15,1);
	//sprintf(str, "Score: %d",game.score[0]);
	render_string(GLUT_STROKE_ROMAN, game.teams[0]->teamName.substr(0, 7).c_str());
	glPopMatrix();

	// Team B score
	glColor3d(1.0f, 1.0f, 1.0f);
	glPushMatrix();
	glTranslatef((ZONEWIDTH*1.5), (ZONEWIDTH*2.2),0);
	glScalef(0.15, 0.15,1);
	render_string(GLUT_STROKE_ROMAN, game.teams[1]->teamName.substr(0,7).c_str());
	glPopMatrix();

	glPushMatrix();
	glTranslatef((ZONEWIDTH*1.5), (ZONEWIDTH*2.0),0);
	glScalef(0.15, 0.15,1);
	sprintf(str, "Score: %d",game.score[1]);
	render_string(GLUT_STROKE_ROMAN, str);
	glPopMatrix();

	glPushMatrix();
	glTranslatef((ZONEWIDTH*1.5), (ZONEWIDTH*1.8),0);
	glScalef(0.15, 0.15,1);
	sprintf(str, "Balls: %d",game.numBallsLeft[1]);
	render_string(GLUT_STROKE_ROMAN, str);
	glPopMatrix();

	// Team C score
	glColor3d(0.282353f, 0.513725f, 0.823529f);
	glPushMatrix();
	glTranslatef(-(ZONEWIDTH*2.4), (ZONEWIDTH*2.2),0);
	glScalef(0.15, 0.15,1);
	render_string(GLUT_STROKE_ROMAN, game.teams[2]->teamName.substr(0,7).c_str());
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-(ZONEWIDTH*2.4), (ZONEWIDTH*2.0),0);
	glScalef(0.15, 0.15,1);
	sprintf(str, "Score: %d",game.score[2]);
	render_string(GLUT_STROKE_ROMAN, str);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-(ZONEWIDTH*2.4), (ZONEWIDTH*1.8),0);
	glScalef(0.15, 0.15,1);
	sprintf(str, "Balls: %d",game.numBallsLeft[2]);
	render_string(GLUT_STROKE_ROMAN, str);
	glPopMatrix();

	// Team D score
	glColor3d(1.0f, 0.941f, 0.0f);
	glPushMatrix();
	glTranslatef(-(ZONEWIDTH*2.4), -(ZONEWIDTH*2.2),0);
	glScalef(0.15, 0.15,1);
	sprintf(str, "Balls: %d",game.numBallsLeft[3]);
	render_string(GLUT_STROKE_ROMAN, str);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-(ZONEWIDTH*2.4), -(ZONEWIDTH*2.0),0);
	glScalef(0.15, 0.15,1);
	sprintf(str, "Score: %d",game.score[3]);
	render_string(GLUT_STROKE_ROMAN, str);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-(ZONEWIDTH*2.4), -(ZONEWIDTH*1.8),0);
	glScalef(0.15, 0.15,1);
	render_string(GLUT_STROKE_ROMAN, game.teams[3]->teamName.substr(0,7).c_str());
	glPopMatrix();


	if(game.gameOver == true) {

		float offset = 100;
		for(unsigned int i = 0; i < 4; i++) {
			if(game.score[i] == game.highScore) {
				switch(i) {
					case 0: glColor3d(0.302f, 0.996f, 0.462745f); break;
					case 1: glColor3d(1.0f, 1.0f, 1.0f); break;
					case 2: glColor3d(0.282353f, 0.513725f, 0.823529f); break;
					case 3: glColor3d(1.0f, 0.941f, 0.0f); break;
					default: glColor3d(1.0f, 1.0f, 1.0f);
				};
				sprintf(str, "%s Wins!",game.teams[i]->teamName.c_str());
				glPushMatrix();
				glTranslatef(-100, offset,0);
				glScalef(0.25, 0.25,1);
				render_string(GLUT_STROKE_ROMAN, str);
				glPopMatrix();
				offset = offset - 50;
			}
		}
	}

	glutSwapBuffers();

}

void MyKeyboardKeys(unsigned char key, int x, int y) {

	if (key == 0x1b)
		exit(0);

	if (key == ' ')
		game.startGame();

}


void MyTextures() {
	Bitmap *image;
	image = new Bitmap();

	if(image == NULL) {
		printf("Error: can not allocate memory for bitmap texture\n");
		myExit(1);
	}

	glGenTextures(6, texture);
	if(image->loadBMP("src/Sprites/ground.bmp")) {
		glBindTexture(GL_TEXTURE_2D, texture[0]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, image->width, image->height, 0, GL_RGB, GL_UNSIGNED_BYTE, image->data);
	}
	else {
		printf("Error: Can not load texture\n");
		myExit(1);
	}

	if(image->loadBMP("src/Sprites/ball.bmp")) {
		glBindTexture(GL_TEXTURE_2D, texture[1]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP );
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP );
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, image->width, image->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, image->data);
	}
	else {
		printf("Error: Can not load texture\n");
		myExit(1);
	}

	if(image->loadBMP("src/Sprites/spritsA.bmp")) {
		glBindTexture(GL_TEXTURE_2D, texture[2]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP );
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP );
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, image->width, image->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, image->data);
	}
	else {
		printf("Error: Can not load texture\n");
		myExit(1);
	}

	if(image->loadBMP("src/Sprites/spritsB.bmp")) {
		glBindTexture(GL_TEXTURE_2D, texture[3]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP );
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP );
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, image->width, image->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, image->data);
	}
	else {
		printf("Error: Can not load texture\n");
		myExit(1);
	}

	if(image->loadBMP("src/Sprites/spritsC.bmp")) {
		glBindTexture(GL_TEXTURE_2D, texture[4]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP );
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP );
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, image->width, image->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, image->data);
	}
	else {
		printf("Error: Can not load texture\n");
		myExit(1);
	}

	if(image->loadBMP("src/Sprites/spritsD.bmp")) {
		glBindTexture(GL_TEXTURE_2D, texture[5]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP );
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP );
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, image->width, image->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, image->data);
	}
	else {
		printf("Error: Can not load texture\n");
		myExit(1);
	}



	if (image) {
		delete image;
	}

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);



}

void initGL(int argc, char** argv) {

	glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA );
    glutInitWindowSize(windowWidth, windowHeight);
    glutInitWindowPosition(100, 150);
    glutCreateWindow("ISU Dodge Ball");

	glutReshapeFunc(MyReshape);
	glutDisplayFunc(MyDisplay);
	glutKeyboardFunc(MyKeyboardKeys);

	MyTextures();


	glClearColor( 0.25f, 0.25f, 0.25f, 1.0f );

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glOrtho(-1 * GRID*RES/2, GRID*RES/2, -1 * GRID*RES/2, GRID*RES/2, -1 * GRID*RES/2, GRID*RES/2);


	glLineWidth(3);
	glPointSize(8);


}



void compile(char *fileName, ISUCode *teamCode) {

	FILE *pFile;
	pFile = fopen(fileName,"r");
	if(pFile == NULL) {
		printf("Error: can not find file: %s\n", fileName);
		myExit(-1);
	}

	unsigned int lineNumber = 1;

	char command[120];
	char function[120];
	char playerType[100];
	unsigned int playerID;
	unsigned int count;
	unsigned int x,y;
	float angle;

	string teamName = string(fileName);
	teamCode->teamName = teamName.substr(0, teamName.length()-4);

	if(teamCode->teamName.length() > 10) {
		teamCode->teamName = teamCode->teamName.substr(0,10);
	}


	while(!feof(pFile)) {

		command[0] = NULL;
		fgets(command, 120, pFile);
		if(command[0] == '#') continue;
		if(command[0] == NULL) continue;
		if(command[0] == 10) continue;

		// parse playerID and function name
		if(sscanf(command, " P%d.%s ", &playerID, function) != 2) {
			printf("Compiler Error (syntax error): %s line: %d\n", fileName, lineNumber);
			myExit(-1);
		}

		playerID--;

		if(playerID > 3) {
			printf("Compiler Error (no team player id: %d): %s line: %d\n", playerID, fileName, lineNumber);
			myExit(-1);
		}

		if(strcmp(function,"Throw") == 0) {
			teamCode->player[playerID].push_back(Instruction(THROUGH));
		} else {
			if(strcmp(function,"Defend")==0) {
				if(sscanf(command, " %s %d ", function, &count) != 2) {
					printf("Compiler Error (function Deffend: bad arguments): %s line: %d\n", fileName, lineNumber);
					myExit(-1);
				}
				teamCode->player[playerID].push_back(Instruction(DEFFEND,count));
			} else {
				if(strcmp(function,"Move")==0) {
					if(sscanf(command, " %s %d %d ", function, &x, &y) != 3) {
						printf("Compiler Error (function Move: bad arguments): %s line: %d\n", fileName, lineNumber);
						myExit(-1);
					}
					if( (x < 0) || (y<0)) {
						printf("Compiler Error (function Move: Move Location must be possitive number): %s line: %d\n", fileName, lineNumber);
						myExit(-1);
					}
					if( (x > 40) || (y>16)) {
						printf("Compiler Error (function Move: Move Location must be  < 41 for x and < 17 for y): %s line: %d\n", fileName, lineNumber);
						myExit(-1);
					}
					teamCode->player[playerID].push_back( Instruction(x,y));
				} else {
					if(strcmp(function,"Turn")==0) {
						if(sscanf(command, " %s %f ", function, &angle) != 2) {
							printf("Compiler Error (function Turn: bad arguments): %s line: %d\n", fileName, lineNumber);
							myExit(-1);
						}
					teamCode->player[playerID].push_back( Instruction(angle));
					} else {
						if(strcmp(function,"Create")==0) {
							if(sscanf(command, " %s %s ", function, playerType) != 2) {
								printf("Compiler Error (function Create: bad arguments): %s line: %d\n", fileName, lineNumber);
								myExit(-1);
							}
							teamCode->newPlayer(playerID, playerType, fileName, lineNumber);
						} else {
							printf("Compiler Error (No function named: %s): %s line: %d\n", function, fileName, lineNumber);
							myExit(-1);
						}
					}
				}
			}
		}

		lineNumber++;
	}

	for(unsigned int i = 0; i < 4; i++) {
		if(teamCode->set[i] == false) {
			printf("Compiler Error (No Starting Position for player: %d)\n", i+1);
			myExit(-1);
		}

		if(teamCode->player[i].size() > 0) {
			if(teamCode->player[i].at(teamCode->player[i].size()-1).opCode == DEFFEND) {
				teamCode->player[i].at(teamCode->player[i].size()-1).repeatCount = 1;
			}
		}
	}



	fclose(pFile);

}

void DrawCall(int extra) {
	glutPostRedisplay();
	glutTimerFunc(30,DrawCall,0);
}

int main(int argc, char** argv) {

	if((argc != 2) && (argc != 5) && (argc != 3) && (argc != 6)) {
		printf("%s: missing argument files\n", argv[0]);
		printf("Required format is \n%s teamA.txt teamB.txt teamC.txt teamD.txt\n", argv[0]);
		printf("%s teamA.txt\n%s teamA.txt Walls.txt\n%s teamA.txt teamB.txt teamC.txt teamD.txt Walls.txt\n",argv[0], argv[0],argv[0]);
		myExit(-1);
	}


	ISUCode *codeA = new ISUCode("Alpha");
	ISUCode *codeB = new ISUCode("Bravo");
	ISUCode *codeC = new ISUCode("Charlie");
	ISUCode *codeD = new ISUCode("Delta");

	compile(argv[1], codeA);

	if((argc == 5) || (argc == 6)) {
		compile(argv[2], codeB);
		compile(argv[3], codeC);
		compile(argv[4], codeD);
	}

	if(argc == 6) {
		game.setWalls(argv[5]);
	}
	if(argc == 3) {
		game.setWalls(argv[2]);
	}

	game.set(codeA, codeB, codeC, codeD);


	initGL(argc, argv);


	glutTimerFunc(30, DrawCall, 0);
	glutMainLoop();



}
